<?php
/**
 * Controlador para métodos de un padre de familia aplicante.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 11:25
 */

namespace App\Http\Controllers;


use App\Repositories\ApplicantGuardianRepository;
use App\Repositories\ApplicantGuardianStudentRepository;
use App\Repositories\ApplicantStudentRepository;
use App\Repositories\MailSuggestoinRepository;
use Illuminate\Http\Request;

class ApplicantGuardianController extends Controller
{
    protected $applicantGuardian;
    protected $applicantStudent;
    protected $mailGuardian;
    protected $applicantGuardianStudent;

    public function __construct(ApplicantGuardianRepository $applicantGuardian, ApplicantStudentRepository $applicantStudent, MailSuggestoinRepository $mailGuardian, ApplicantGuardianStudentRepository $applicantGuardianStudent)
    {
        $this->applicantGuardian = $applicantGuardian;
        $this->applicantStudent = $applicantStudent;
        $this->mailGuardian = $mailGuardian;
        $this->applicantGuardianStudent = $applicantGuardianStudent;
    }

    public function postSaveApplicantGuardian(Request $request){
        try{
            $data = $request->all();
            $father = json_decode($data['father'],true);
            $father['serial_cou'] = $data['serial_cou'];
            $father['first_name_agd'] = mb_strtoupper(isset($father['first_name_agd']) ? $father['first_name_agd'] : null,'utf-8');
            $father['last_name_agd'] = mb_strtoupper(isset($father['last_name_agd']) ? $father['last_name_agd'] : null,'utf-8');
            $father['main_street_agd'] = mb_strtoupper(isset($father['main_street_agd']) ? $father['main_street_agd']: null,'utf-8');
            $father['city_residence_agd'] = mb_strtoupper(isset($father['city_residence_agd']) ? $father['city_residence_agd']: null,'utf-8');
            $father['sector_agd'] = mb_strtoupper(isset($father['sector_agd']) ? $father['sector_agd'] : null,'utf-8');
            $father['work_company_agd'] = mb_strtoupper(isset($father['work_company_agd']) ? $father['work_company_agd']: null,'utf-8');
            $father['number_applicants_agd'] = $data['number_applicants_agd'];
            $applicantGuardian = $this->applicantGuardian->saveApplicantGuardian($father);
            $students = json_decode($data['students'],true);
            foreach ($students as $key => $student) {
                $student['first_name_ast'] = mb_strtoupper(isset($student['first_name_ast']) ? $student['first_name_ast'] : null,'utf-8');
                $student['last_name_ast'] = mb_strtoupper(isset($student['last_name_ast']) ? $student['last_name_ast'] : null,'utf-8');
                $student['school_city_last_school_ast'] = mb_strtoupper(isset($student['school_city_last_school_ast']) ? $student['school_city_last_school_ast'] : null,'utf-8');
                $student['last_school_ast'] = mb_strtoupper(isset($student['last_school_ast']) ? $student['last_school_ast'] : null,'utf-8');
                $student['serial_agd'] = $applicantGuardian->serial_agd;
                $student['serial_scy'] = $data['serial_scy'];
                $student['ip_address_ast'] = $data['ip_address_ast'];
                $student['serial_cou_last_school_ast'] = '61';
                $applicant = $this->applicantStudent->saveApplicantStudent($student);
                $applicantFatherStudent['serial_agd'] = $applicantGuardian->serial_agd;
                $applicantFatherStudent['serial_ast'] = $applicant->serial_ast;
                $applicantFatherStudent['relationship_ast'] = $student['relationship_ast'];
                $this->applicantGuardianStudent->saveApplicantGuardianStudent($applicantFatherStudent);
            }

            $this->mailGuardian->mailApplicantGuardian($applicantGuardian);
            $this->mailGuardian->mailApplicantApprover($applicantGuardian);
            return response()->json(['success' => 'true',
                'message' => 'Se ha registrado la solicitud'], 200);

        }catch (Exception $ex){
            return response()->json($ex);
        }
    }

}