<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\DateDayConfigurationRepository;
use Laravel\Lumen\Routing\Controller as BaseController;

class DateDayConfigurationController extends BaseController {

    protected $dateDayConfiguration;

    public function __construct(DateDayConfigurationRepository $dateDayConfiguration) {
        $this->dateDayConfiguration = $dateDayConfiguration;
    }

    /**
     * Método que devuelve la configuracion por fecha dia
     * @since   2018-04-14
     * @author  Erick Vaca <epvaca@rutatec.com>
     *
     * @param   array $request 
     * @return  ListObject $dateDayConfiguration
     * 
     * @edit    2018-04-14<br />
     *          Erick Vaca <epvaca@rutatec.com><br />
     *          Creación del método<br/>
     *          #edit1
     */
    public function getDateDayConfiguration($date) {      
        $dateDayConfig = $this->dateDayConfiguration->getDateDayConfiguration($date);

        return response()->json($dateDayConfig);
    }

}
