<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\EventRepository;
use App\Repositories\ProfileRepository;
use App\Repositories\UserProfileRepository;
use App\Repositories\EventProfileRepository;
use App\Repositories\DateDayConfigurationRepository;
use Laravel\Lumen\Routing\Controller as BaseController;

class EventProfileController extends BaseController {

    protected $event;
    protected $profile;
    protected $userProfile;
    protected $eventProfile;
    protected $dateDayConfiguration;

    public function __construct(EventRepository $event, ProfileRepository $profile, UserProfileRepository $userProfile, EventProfileRepository $eventProfile, DateDayConfigurationRepository $dateDayconfiguration) {
        $this->profile = $profile;
        $this->event = $event;
        $this->userProfile = $userProfile;
        $this->eventProfile = $eventProfile;
        $this->dateDayConfiguration = $dateDayconfiguration;
    }

    public function postEventProfile(Request $request) {
        $this->validate($request, [
            'serial_prf' => 'required'
        ]);
        $eventProfile = $this->event->getEventProfile($request->input('serial_prf'));
        return response()->json($eventProfile);
    }
    
    
    
    public function postStatusEvent(){
        $status_event=$this->event->getStatusEvent();
        return response()->json($status_event);
    }
    
  public function postUserEvents(Request $request) {
      $this->validate($request, [
            'serial_usr' => 'required'
        ]);
        $profiles = $this->userProfile->getUserProfiles($request->input('serial_usr'));
        
        $eventsProfile=$this->eventProfile->getEventProfile($profiles);
        return response()->json($eventsProfile);
    }
    
   
    
    public function getHolidays(){
        $holidays=$this->dateDayConfiguration->getHolidays();
        return response()->json($holidays);
    }

}
