<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\IncidenceStudentDetailRepository;
use Laravel\Lumen\Routing\Controller as BaseController;

/**
 * Controlador para Incidence Student Detail
 * @since   2018-03-28
 * @author  Erick Vaca <epvaca@rutatec.com>
 *
 * @edit    2018-03-28<br />
 *          Erick Vaca <epvaca@rutatec.com><br /><br/>
 *          Creación del controlador<br/>
 *          #edit1
 */
class IncidenceStudentDetailController extends BaseController {

    protected $incidenceStudentDetail;

   /**
     * Constructor
     * @since   2018-03-28
     * @param   IncidenceStudentDetailRepository  $incidenceStudentDetail repositorio
     * @author   Erick Vaca <epvaca@rutatec.com><br /><br/>
     *
     */
    public function __construct(IncidenceStudentDetailRepository $incidenceStudentDetail){
        $this->incidenceStudentDetail = $incidenceStudentDetail;
    }



  /**
     * Método que guarda configuracion
     * @since   2018-03-28
     * @author  Erick Vaca <epvaca@rutatec.com> 
     *
     * @param   array $request
     * @return  
     * 
     */
    public function postSaveIncidenceStudentDetail(Request $request) {
        try {
            //Procesamiento
            $this->validate($request, [
                'serial_isd' => 'required',                
            ]);
            $result = $this->incidenceStudentDetail->saveIncidenceStudentDetail($request);
            
            return response()->json($result);    
        } catch (Exception $ex) {
            return false;
        }
    }


}