<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\LevelSectionYearRepository;
use Laravel\Lumen\Routing\Controller as BaseController;

/**
 * Controlador para niveles
 * @since   2018-03-15
 * @author  Erick Vaca <epvaca@rutatec.com>
 *
 * @edit    2018-03-15<br />
 *          Erick Vaca <epvaca@rutatec.com><br /><br/>
 *          Creación del controlador<br/>
 *          #edit1
 */
class LevelController extends BaseController {

    protected $levelSectionYear;

    /**
     * Constructor
     * @since   2018-03-15
     * @param   SectionRepository  $section repositorio
     * @author   Erick Vaca <epvaca@rutatec.com><br /><br/>
     *
     */
    public function __construct(LevelSectionYearRepository $levelSectionYear) {
        $this->levelSectionYear = $levelSectionYear;
    }

 
    /**
     * Método para obtener niveles por serial de anio lectivo y seccion
     * @since   2018-03-15
     * @param   integer serial_scy año lectivo
     * @param   integer serial_set seccion
     * @author   Erick Vaca <epvaca@rutatec.com><br /><br/>
     * @return  json resultado
     *
     */
    public function getLevelsBySchoolYearSection($serial_scy, $serial_set) {        
        $levels = $this->levelSectionYear->getLevelBySectionSchoolYear($serial_scy, $serial_set);
        return response()->json($levels);
    }

}