<?php

namespace App\Http\Controllers;

use App\Repositories\MailSuggestoinRepository;
use Illuminate\Http\Request;
use Laravel\Lumen\Routing\Controller as BaseController;
use League\Flysystem\Exception;


/**
 * Controlador para buzon de sugerencias
 * @since   2017-06-26
 * @author  Henry Vivanco <hvvivanco@rutatec.com>
 *
 */
class MailSuggestionController extends BaseController
{

    protected $appSetup;

    public function __construct(MailSuggestoinRepository $appSetup)
    {
        $this->appSetup = $appSetup;
    }

    /**
     * Método que envía sugerencias al correo
     * @since 2018-06-28
     * @author Henry Vivanco <hvvivanco@rutatec.com>
     * @return Message
     */
    public function getSuggestion(Request $request)
    {
        $this->validate($request, [
            'msg' => 'required',
        ]);
        $appSetup = $this->appSetup->getSuggestions($request);
        return "La sugerencia se ha enviado correctamente";
    }

    public function getSuggestions($mailFrom, $mailTo)
    {
        try {
            $appSetup = $this->appSetup->getSuggestion($mailFrom, $mailTo);
            if ($appSetup == true) {
                return "Email enviado";
            } else {
                return "Email no enviado";
            }
        } catch (Exception $e) {
            return $e;
        }
    }
}