<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\NewRepository;
use Laravel\Lumen\Routing\Controller as BaseController;

class NewController extends BaseController {

    protected $new;
    protected $image_path = 'img/news/';
    
    public function __construct(NewRepository $new) {
        $this->new = $new;
    }

    public function getAllNews() {
        $allNews = $this->new->getNews();
        $schoolSetup= \App\Models\SchoolSetup::first();
        if ($allNews != null) {
            $news = array();
            foreach ($allNews as $n) {
                $news[$n->serial_new]['serial_new'] = $n->serial_new;
                $news[$n->serial_new]['title_new'] = $n->title_new;
                $news[$n->serial_new]['publication_date_new'] = $n->publication_date_new;
                $news[$n->serial_new]['priotity'] = $n->priority_new;
                foreach ($n->imgNews as $img) {
                    $img->name_img =  env('SERVER_LEARNBOX') .$this->image_path. $img->name_img;
                }
                $news[$n->serial_new]['images'] = $n->imgNews;
            }
            foreach ($news as $key => $value) {
                if ($value == null) {
                    unset($news[$key]);
                    $news[] = $value;
                }
            }
            $news = array_values($news);
            return response()->json($news);
        }

        return response()->json(false);
    }

    public function getNew($serial_new) {
        $new_detail = $this->new->findById($serial_new);
        $schoolSetup = \App\Models\SchoolSetup::first();
        $new = array();
        $new['serial_new'] = $new_detail->serial_new;
        $new['title_new'] = $new_detail->title_new;
        $new['description_new'] = $new_detail->description_new;
        $new['publication_date_new'] = $new_detail->publication_date_new;
        $new['images']=$new_detail->imgNews;
        
        foreach ($new['images'] as $img) {
            $img->name_img = env('SERVER_LEARNBOX') . $this->image_path . $img->name_img;
        }

        return response()->json($new);
    }

    public function getWebView() {
        $schoolSetup = \App\Models\SchoolSetup::first();
        return response()->json($schoolSetup->web_view_sst);
    }

}
