<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\ProfileRepository;
use Laravel\Lumen\Routing\Controller as BaseController;

class ProfileController extends BaseController {

    protected $profile;

    public function __construct(ProfileRepository $profile){
        $this->profile = $profile;
    }

    public function getProfiles() {

        $profiles = $this->profile->getProfiles();

        return response()->json($profiles);
    }

    public function postProfilesApp(Request $request) {
        $profiles = $this->profile->getProfilesApp($request->input('serial_usr'));
        foreach ($profiles as $profile) {
            if ($profile->serial_prf != 2 && $profile->serial_prf != 3) {
                $profile->serial_prf = 0;
                $profile->name_prf = 'Empleado';
            }
        }
        $profiles = $profiles->unique();
        if (sizeof($profiles) > 0) {
            return response()->json($profiles);
        }
        return response()->json(false);
    }

}
