<?php
/**
 * Controlador para métodos sobre estado/provincia.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 15:28
 */

namespace App\Http\Controllers;


use App\Repositories\StateRepository;
use Illuminate\Http\Request;

class StateController extends Controller
{
    protected $state;

    public function __construct(StateRepository $state)
    {
        $this->state = $state;
    }

    /**
     * Método para obtener provincias(estados) según el país
     * @author Henry Vivanco <hvvivanco@rutatec.com>
     * @since  2019-01-21
     * @return array $states
     */
    public function getStates(Request $request){
        $this->validate($request, [
            'serial_cou' => 'required',
        ]);
        $serialCountry = $request->get('serial_cou');
        $states = $this->state->getStates($serialCountry);
        return response()->json($states);
    }

}