<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Repositories\SubjectCourseRepository;
use Laravel\Lumen\Routing\Controller as BaseController;

/**
 * Controlador para materias obligatorias
 * @since   2017-07-09
 * @author  Erick Vaca <epvaca@rutatec.com>
 *
 * @edit    2017-07-09<br />
 *          Erick Vaca <epvaca@rutatec.com><br /><br/>
 *          Creación del controlador<br/>
 *          #edit1
 */
class SubjectCourseController extends BaseController {

    protected $subjectCourse;

    /**
     * Constructor
     * @since   2016-07-09
     * @param   SubjectCourseRepository  $subjectCourse repositorio
     * @author   Erick Vaca <epvaca@rutatec.com><br /><br/>
     *
     */
    public function __construct(SubjectCourseRepository $subjectCourse){
        $this->subjectCourse = $subjectCourse;
    }

    /**
     * Método para obtener materias
     * @since   2016-07-09
     * @param   integer serial_scy año lectivo
     * @param   integer $serial_sec seccion
     * @param   integer $serial_spt especialidad
     * @param   integer $serial_lvl nivel
     * @author   Erick Vaca <epvaca@rutatec.com><br /><br/>
     * @return  json resultado
     *
     */
    public function getSubjectsBySchoolYearSectionLevel($serial_scy, $serial_set, $serial_lvl, $serial_spt){

        $subjectList = $this->subjectCourse->getSubjectsBySchoolYearSectionLevel($serial_scy, $serial_set, $serial_lvl, $serial_spt);

        return response()->json($subjectList);
        
    }
    
    
}