<?php
/**
 * Repositorio para consultas respecto a padre de familia aplicante.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 17:55
 */

namespace App\Repositories;


use App\Models\ApplicantGuardian;
use App\Repositories\BaseRepository;

class ApplicantGuardianRepository extends BaseRepository
{

    protected $applicantGuardian;

    public function __construct(ApplicantGuardian $applicantGuardian)
    {
        $this->applicantGuardian = $applicantGuardian;
    }

    public function saveApplicantGuardian($data){
        $applicantGuardian = ApplicantGuardian::where('id_agd','=',$data['id_agd'])->first();
        if ($applicantGuardian) {
            $applicantGuardian->serial_cou = !empty($data['serial_cou']) ? $data['serial_cou'] : $applicantGuardian->serial_cou;
            //$applicantGuardian->serial_ste = !empty($data['serial_ste']) ? $data['serial_ste'] : $applicantGuardian->serial_ste;
            //$applicantGuardian->serial_cnt = !empty($data['serial_cnt']) ? $data['serial_cnt'] : $applicantGuardian->serial_cnt;
            //$applicantGuardian->serial_par = !empty($data['serial_cou']) ? $data['serial_cou'] : $applicantGuardian->serial_par;
            $applicantGuardian->first_name_agd = !empty($data['first_name_agd']) ? $data['first_name_agd'] : $applicantGuardian->first_name_agd;
            $applicantGuardian->last_name_agd = !empty($data['last_name_agd']) ? $data['last_name_agd'] : $applicantGuardian->last_name_agd;
            $applicantGuardian->id_agd = !empty($data['id_agd']) ? $data['id_agd'] : $applicantGuardian->id_agd;
            $applicantGuardian->email_agd = !empty($data['email_agd']) ? $data['email_agd'] : $applicantGuardian->email_agd;
            $applicantGuardian->phone_agd = !empty($data['phone_agd']) ? $data['phone_agd'] : $applicantGuardian->phone_agd;
            $applicantGuardian->main_street_agd = !empty($data['main_street_agd']) ? $data['main_street_agd'] : $applicantGuardian->main_street_agd;
            $applicantGuardian->number_street_agd = !empty($data['number_street_agd']) ? $data['number_street_agd'] : $applicantGuardian->number_street_agd;
            $applicantGuardian->city_residence_agd = !empty($data['city_residence_agd']) ? $data['city_residence_agd'] : $applicantGuardian->city_residence_agd;
            $applicantGuardian->secondary_street_agd = !empty($data['secondary_street_agd']) ? $data['secondary_street_agd'] : $applicantGuardian->secondary_street_agd;
            $applicantGuardian->sector_agd = !empty($data['sector_agd']) ? $data['sector_agd'] : $applicantGuardian->sector_agd;
            $applicantGuardian->parent_ex_student = !empty($data['parent_ex_student']) ? $data['parent_ex_student'] : $applicantGuardian->parent_ex_student;
            $applicantGuardian->work_company_agd = !empty($data['work_company_agd']) ? $data['work_company_agd'] : $applicantGuardian->work_company_agd;
            $applicantGuardian->number_applicants_agd = !empty($data['number_applicants_agd']) ? $data['number_applicants_agd'] : $applicantGuardian->number_applicants_agd;
            $applicantGuardian->save();
        } else {
            $applicantGuardian = new ApplicantGuardian($data);
            $applicantGuardian->save();
        }
        return $applicantGuardian;

    }

}