<?php
/**
 * Created by PhpStorm.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 5/1/2020
 * Time: 13:43
 */

namespace App\Repositories;


use App\Models\ApplicantGuardianStudent;
use Illuminate\Database\Eloquent\Model;

class ApplicantGuardianStudentRepository extends Model
{
    protected $applicantGuardianStudent;

    public function __construct(ApplicantGuardianStudent $applicantGuardianStudent)
    {
        $this->applicantGuardianStudent = $applicantGuardianStudent;
    }

    public function saveApplicantGuardianStudent($applicantGuardianStudent){

        $result = ApplicantGuardianStudent::where('serial_ast','=',$applicantGuardianStudent['serial_ast'])
            ->where('serial_agd','=',$applicantGuardianStudent['serial_agd'])
            ->first();
        if ($result) {
            $result->serial_agd = !empty($applicantGuardianStudent['serial_agd']) ? $applicantGuardianStudent['serial_agd'] : $result->serial_agd;
            $result->serial_ast = !empty($applicantGuardianStudent['serial_ast']) ? $applicantGuardianStudent['serial_ast'] : $result->serial_ast;
            $result->relationship_ast = !empty($applicantGuardianStudent['relationship_ast']) ? $applicantGuardianStudent['relationship_ast'] : $result->relationship_ast;
            $result->save();
        } else {
            $result = new ApplicantGuardianStudent($applicantGuardianStudent);
            $result->save();
            return $result;
        }

    }

    public function getGuardianStudent($serial_ast, $type_guardian){
        $result = ApplicantGuardianStudent::where('serial_ast','=',$serial_ast)
            ->where('relationship_ast','=',$type_guardian)
            ->join('applicant_guardian as agd','agd.serial_agd','=','applicant_guardian_student.serial_agd')
            ->select('agd.*','applicant_guardian_student.relationship_ast')
            ->first();
        return $result;
    }

}