<?php

namespace App\Repositories;

use App\Models\AttendanceLogAtl;
use App\Repositories\DateDayConfigurationRepository;
use App\Repositories\LevelSectionYearRepository;
use App\Repositories\BaseRepository;

class AttendanceLogAtlRepository extends BaseRepository {

    protected $modelClass = AttendanceLogAtl::class;

//    protected $course;
    //Declaración del constructor
    public function __construct(AttendanceLogAtl $attendancelog, DateDayConfigurationRepository $dateDayConfiguration, LevelSectionYearRepository $levelSectionYearRepository) {
        $this->attendance = $attendancelog;
        $this->dateDayConfiguration = $dateDayConfiguration;
        $this->levelSectionYearRepository = $levelSectionYearRepository;
    }

    public function save($serial_usr, $serial_scd, $serial_sbc, $serial_osb, $date) {
        $day = $this->dateDayConfiguration->getDateDayConfiguration($date);
        $scheduele = \App\Models\Schedule::find($serial_scd);
        $course = \App\Models\Course::find($scheduele->serial_crs);
        $subperiod = $this->levelSectionYearRepository->getSubperiodByDateSchoolYearSectionLevel($date, $course->serial_scy, $course->serial_set, $course->serial_lvl);
        $attendanceLogAtl = new AttendanceLogAtl(array('serial_usr' => $serial_usr, 'serial_scd' => $serial_scd, 'serial_sbp' => $subperiod->serial_sbp, 'serial_sbc' => $serial_sbc == '-1' ? null : $serial_sbc, 'serial_osb' => $serial_osb == '-1' ? null : $serial_osb, 'serial_ddc' => $day->serial_ddc, 'date_atl' => Date('Y-m-d H:i:s'), 'status_atl' => 'ACTIVE'));
        $attendanceLogAtl->save();
    }

}
