<?php
/**
 * Repositorio para consulta de paises.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 11:13
 */

namespace App\Repositories;


use App\Models\Counties;
use App\Models\Country;
use App\Models\Parish;
use App\Models\State;
use App\Models\ZoneAddress;

class CountryRepository extends BaseRepository
{
    protected $country;

    public function __construct(Country $country)
    {
        $this->country = $country;
    }

    /**
     * Método para obtener lista de países
     * @author Henry Vivanco <hvvivanco@rutatec.com>
     * @since  2019-01-21
     * @return array $countries
     */
    public function getCountries(){
        $countries = Country::where('status_cou','=','ACTIVE')
            ->pluck('name_cou','serial_cou');
        return $countries;
    }

}