<?php

namespace App\Repositories;

use App\Models\DateDayConfiguration;
use App\Repositories\BaseRepository;

class DateDayConfigurationRepository extends BaseRepository {

    protected $modelClass = DateDayConfiguration::class;
    protected $employee;

    //Declaración del constructor
    public function __construct(DateDayConfiguration $dateDayConfiguration) {
        $this->dateDayConfiguration = $dateDayConfiguration;
    }

   
    public function getDateDayConfiguration($date) {
        $query = $this->newQuery();
        $query->where('date_ddc', '=', $date);
        $query->where('status_ddc', '=', 'ACTIVE');
        return $this->doQueryFirst($query);
    }
    
    public function getHolidays() {
        $holidays = $this->newQuery();
        $holidays->where('day_ddc', '<>', 'SATURDAY');
        $holidays->where('day_ddc', '<>', 'SUNDAY');
        $holidays->where('status_ddc', '=', 'ACTIVE');
        $holidays->where('holiday_ddc', '=', 1);
        return $this->doQueryGet($holidays)->toArray();
    }

    public function getStartAndEndDatesByYear($serial_scy) {
        $query = $this->newQuery();
        $query->where('status_ddc', '=', 'ACTIVE');
        $query->where('serial_scy','=',$serial_scy);
        $query->selectRaw('min(date_ddc) as startDate,max(date_ddc) as endDate');
        return $this->doQueryFirst($query)->toArray();
    }

}
