<?php

namespace App\Repositories;

use App\Models\ExtracurricularActivitiesAttendance;
use App\Models\ExtracurricularActivitiesRegistration;

class ExtracurricularActivitiesAttendanceRepository extends BaseRepository {

    protected $modelClass = ExtracurricularActivitiesAttendance::class;
    protected $extracurricularActivitiesAttendance;

    //Declaración del constructor
    public function __construct(ExtracurricularActivitiesAttendance $extracurricularActivitiesAttendance) {
        $this->extracurricularActivitiesAttendance = $extracurricularActivitiesAttendance;
    }


    public function setAttendanceIfApply($serial_std,$date,$day,$type_ace){

        $studentExtracurricular=ExtracurricularActivitiesRegistration::join('group_extracurricular_activities as gea',function ($join) use($date){
           $join->on('gea.id','extracurricular_activities_registration.group_extracurricular_activities_id')
               ->where('gea.start_date','<=',$date)
               ->where('gea.end_date','>=',$date);
        })->join('extracurricular_activities_days as ead',function($join){
            $join->on('ead.group_extracurricular_activities_id','extracurricular_activities_registration.group_extracurricular_activities_id');
        })->join('days as dys',function ($join)use($day){
            $join->on('dys.id','ead.days_id')
            ->where('dys.status','=','ACTIVE')
                ->where('dys.name_english','=',$day);
        })->where('extracurricular_activities_registration.status','=','ACTIVE')
            ->where('extracurricular_activities_registration.serial_std','=',$serial_std)
            ->select('extracurricular_activities_registration.*')
            ->first();
        if($studentExtracurricular){
            //verificar si ya existe
            $extracurricularAttendanceExist=$this->newQuery();
            $extracurricularAttendanceExist->where('registered_id',$studentExtracurricular->id)
            ->where('attendance_date',$date);
            $extracurricularAttendance=$this->doQueryFirst($extracurricularAttendanceExist);
            if($extracurricularAttendance && $type_ace!='UNEXCUSED_ABSENCE'){
                $extracurricularAttendance->delete();
                return null;
            }else if($type_ace=='UNEXCUSED_ABSENCE'){
                if(!$extracurricularAttendance){
                    $extracurricularAttendance= new ExtracurricularActivitiesAttendance();
                    $extracurricularAttendance->registered_id=$studentExtracurricular->id;
                    $extracurricularAttendance->attendance_type=$type_ace;
                    $extracurricularAttendance->attendance_date=$date;
                    $extracurricularAttendance->save();
                }else{
                    $extracurricularAttendance->registered_id=$studentExtracurricular->id;
                    $extracurricularAttendance->attendance_type=$type_ace;
                    $extracurricularAttendance->attendance_date=$date;
                    $extracurricularAttendance->save();
                }

                return $extracurricularAttendance;
            }
        }else{
            return null;
        }
    }


}
