<?php

namespace App\Repositories;

use App\Models\Course;
use App\Models\SchoolYear;
use App\Models\Period;
use App\Models\Subperiod;
use App\Repositories\BaseRepository;

class GlobalRepository extends BaseRepository
{

    protected $schoolYear;
    protected $period;
    protected $subperiod;

    //Declaración del constructor
    public function __construct(SchoolYear $schoolYear, Period $period,Subperiod $subperiod)
    {
        $this->schoolYear = $schoolYear;
        $this->period = $period;
        $this->subperiod=$subperiod;
    }

    public function truncate($number, $digitos, $serial_scy = 0, $serial_prd = 0, $serial_sbp = 0)
    {

        $type = "TRUNCATED";
        $schoolYear=$this->schoolYear->find($serial_scy);
        if ($serial_scy) {

            $type = $schoolYear->type_calculation_scy;
        }

        if ($serial_prd) {
            $period = $this->period->find($serial_prd);
            $type = $period->type_calculation_prd;
        }

        if ($serial_sbp) {

            $type = $this->suberiod->type_calculation_sbp;
        }

        if ($type == "TRUNCATED") {
            $parte = explode(".", $number);
            if (count($parte) == 1) {
                $despues_coma = substr("000000", 0, $digitos);
            } else {
                $despues_coma = substr($parte[1], 0, $digitos);
            }
            return (double)($parte[0] . "." . $despues_coma);
        } else {
            return (double)round($number, $digitos);
        }
    }


}
