<?php

namespace App\Repositories;

use App\Models\IconCatalogue;
use App\Models\Summary;
use App\Repositories\BaseRepository;

class IconCatalogueRepository extends BaseRepository {

    protected $modelClass = IconCatalogue::class;
    protected $iconCatalogue;
    protected $summary;

    //Declaración del constructor
    public function __construct(IconCatalogue $iconCatalogue, Summary $summary) {
        $this->iconCatalogue = $iconCatalogue;
        $this->summary=$summary;
    }

   
    public function getIconsEmployee($serial_emp) {
        $icons = $this->summary->newQuery();
        $icons->join('icon_catalogue', 'icon_catalogue.serial_ict', '=', 'summary.serial_ict');
        $icons->where('summary.serial_emp','=',$serial_emp);
        $icons->where('status_ict', '=', 'ACTIVE');
        $icons->where('status_sum', '=', 'ACTIVE');
        $icons->select('icon_catalogue.serial_ict');

        return $this->doQueryGet($icons);
    }

}
