<?php

namespace App\Repositories;

use App\Models\LevelGeneralObjectives;
use App\Models\OptionalSubject;
use App\Models\SubjectCourse;
use App\Models\SubjectGeneralObjectives;


class LevelGeneralObjectivesRepository extends BaseRepository {

    protected $modelClass = LevelGeneralObjectives::class;

    protected $levelGeneralObjectives;


    public function __construct(LevelGeneralObjectives $levelGeneralObjectives) {
        $this->levelGeneralObjectives = $levelGeneralObjectives;
    }


    public function getLevelGeneralObjectivesSelectable($serial_sbc, $serial_osb, $serial_lvl, $serial_set) {
        $levelGeneralObjectives = $this->newQuery();
        if (strtoupper($serial_sbc) != 'NULL') {
            $subjectCourse = SubjectCourse::where('serial_sbc', '=', $serial_sbc)
                ->where('status_sbc', '=', 'ACTIVE')
                ->first();
            $levelGeneralObjectives->where('serial_aca', '=', $subjectCourse->serial_aca);
        }
        if (strtoupper($serial_osb) != 'NULL') {
            $optionalSubject = OptionalSubject::where('serial_osb', '=', $serial_osb)
                ->where('status_osb', '=', 'ACTIVE')
                ->first();
            $levelGeneralObjectives->where('serial_aca', '=', $optionalSubject->serial_aca);
        }
        $levelGeneralObjectives->where('selectable', '=', 'YES')
            ->where('serial_lvl', '=', $serial_lvl)
            ->where('serial_set', '=', $serial_set)
            ->where('status_lgo', '=', 'ACTIVE')
            ->with('generalAreaObjectives')
            ->with('subjectGeneralObjectives');
        $levelGeneralObjectives= $this->doQueryGet($levelGeneralObjectives);
        if(sizeof($levelGeneralObjectives)>0) {
            foreach ($levelGeneralObjectives as $key=>$levelGeneralObjective){
                $result[$key]['serial_lgo']=$levelGeneralObjective->serial_lgo;
                $result[$key]['description_gao']=$levelGeneralObjective->generalAreaObjectives->description_gao;
                $result[$key]['is_ministry_objective']=$levelGeneralObjective->generalAreaObjectives->is_ministry_objective;
                $result[$key]['assigned']=$levelGeneralObjective->subjectGeneralObjectives!=null?true:false;
            }
        }else{
            $result = false;
        }
        usort($result, function($a, $b)
        {
            return strcmp($a['description_gao'], $b['description_gao']);
        });
        return $result;
    }


    function saveLevelGeneralObjective($serial_lvl,$serial_set,$serial_gao,$serial_aca){
        $levelGeneralObjectives = new LevelGeneralObjectives();
        $levelGeneralObjectives->serial_lvl=$serial_lvl;
        $levelGeneralObjectives->serial_set=$serial_set;
        $levelGeneralObjectives->serial_gao=$serial_gao;
        $levelGeneralObjectives->selectable='YES';
        $levelGeneralObjectives->status_lgo='ACTIVE';
        $levelGeneralObjectives->serial_aca=$serial_aca;
        $levelGeneralObjectives->save();
        return $levelGeneralObjectives;
    }


}
