<?php

namespace App\Repositories;

use App\Models\LevelIndicatorsUnit;
use App\Models\LevelPlanningUnit;
use App\Models\SubjectPlanningUnit;


class LevelIndicatorsUnitRepository extends BaseRepository {

    protected $modelClass = LevelIndicatorsUnit::class;

    protected $levelIndicatorsUnit;


    public function __construct(LevelIndicatorsUnit $levelIndicatorsUnit) {
        $this->levelIndicatorsUnit = $levelIndicatorsUnit;
    }
    public function getLevelIndicatorsUnitSelectable($serial_spu) {
        $levelIndicatorsUnit = $this->newQuery();
        $subjectPlanningUnit = SubjectPlanningUnit::where('serial_spu', '=', $serial_spu)
            ->where('status_spu', '=', 'ACTIVE')
            ->first();
        $levelPlanningUnit = LevelPlanningUnit::where('serial_lpu', '=', $subjectPlanningUnit->serial_lpu)
            ->where('status_lpu', '=', 'ACTIVE')
            ->first();
        $levelIndicatorsUnit->where('selectable', '=', 'YES')
            ->where('serial_aca', '=', $levelPlanningUnit->serial_aca)
            ->where('serial_lvl', '=', $levelPlanningUnit->serial_lvl)
            ->where('serial_set', '=', $levelPlanningUnit->serial_set)
            ->where('status_liu', '=', 'ACTIVE')
            ->with('achievementIndicatorsUnit')
            ->with(array('subjectIndicatorsUnit' => function ($query) use ($serial_spu) {
                $query->where('serial_spu', '=', $serial_spu);
            }));
        $levelIndicatorsUnits= $this->doQueryGet($levelIndicatorsUnit);
        if(sizeof($levelIndicatorsUnits)>0){
            foreach ($levelIndicatorsUnits as $key=>$levelIndicatorsUnitObj){
                $result[$key]['serial_liu']=$levelIndicatorsUnitObj->serial_liu;
                $result[$key]['description_aiu']=$levelIndicatorsUnitObj->achievementIndicatorsUnit->description_aiu;
                $result[$key]['is_ministry_aiu']=$levelIndicatorsUnitObj->achievementIndicatorsUnit->is_ministry_aiu;
                $result[$key]['assigned']=$levelIndicatorsUnitObj->subjectIndicatorsUnit!=null?true:false;
            }
        }else{
            $result= false;
        }
        return $result;
    }


    function saveLevelIndicatorsUnit($serial_lvl,$serial_set,$serial_aiu,$serial_aca){
        $levelIndicatorsUnit = new LevelIndicatorsUnit();
        $levelIndicatorsUnit->serial_lvl=$serial_lvl;
        $levelIndicatorsUnit->serial_set=$serial_set;
        $levelIndicatorsUnit->serial_aiu=$serial_aiu;
        $levelIndicatorsUnit->selectable='YES';
        $levelIndicatorsUnit->status_liu='ACTIVE';
        $levelIndicatorsUnit->serial_aca=$serial_aca;
        $levelIndicatorsUnit->save();
        return $levelIndicatorsUnit;
    }


}
