<?php

namespace App\Repositories;

use App\Models\LevelPlanningUnit;
use App\Models\OptionalSubject;
use App\Models\SubjectCourse;


class LevelPlanningUnitRepository extends BaseRepository {

    protected $modelClass = LevelPlanningUnit::class;

    protected $levelPlanningUnit;


    public function __construct(LevelPlanningUnit $levelPlanningUnit) {
        $this->levelPlanningUnit = $levelPlanningUnit;
    }
    public function getLevelPlanningUnitSelectable($serial_sbc, $serial_osb, $serial_lvl, $serial_set) {
        $levelPlanningUnit = $this->newQuery();
        if (strtoupper($serial_sbc) != 'NULL') {
            $subjectCourse = SubjectCourse::where('serial_sbc', '=', $serial_sbc)
                ->where('status_sbc', '=', 'ACTIVE')
                ->first();
            $levelPlanningUnit->where('serial_aca', '=', $subjectCourse->serial_aca);
        }
        if (strtoupper($serial_osb) != 'NULL') {
            $optionalSubject = OptionalSubject::where('serial_osb', '=', $serial_osb)
                ->where('status_osb', '=', 'ACTIVE')
                ->first();
            $levelPlanningUnit->where('serial_aca', '=', $optionalSubject->serial_aca);
        }
        $levelPlanningUnit->where('selectable', '=', 'YES')
            ->where('serial_lvl', '=', $serial_lvl)
            ->where('serial_set', '=', $serial_set)
            ->where('status_lpu', '=', 'ACTIVE')
            ->with('planningUnit')
            ->with('subjectPlanningUnit');
        $levelPlanningUnits= $this->doQueryGet($levelPlanningUnit);
        if(sizeof($levelPlanningUnits)>0){
            foreach ($levelPlanningUnits as $key=>$levelPlanningUnitObj){
                $result[$key]['serial_lpu']=$levelPlanningUnitObj->serial_lpu;
                $result[$key]['description_put']=$levelPlanningUnitObj->planningUnit->description_put;
                $result[$key]['is_ministry_put']=$levelPlanningUnitObj->planningUnit->is_ministry_put;
                $result[$key]['assigned']=$levelPlanningUnitObj->subjectPlanningUnit!=null?true:false;
            }
        }else{
            $result= false;
        }
        usort($result, function($a, $b)
        {
            return strcmp($a['description_put'], $b['description_put']);
        });
        return $result;
    }

    public function getLevelPlanningUnit($serial_lpu){
        $levelPlanningUnit = LevelPlanningUnit::where('serial_lpu', '=', $serial_lpu)
            ->where('status_lpu', '=', 'ACTIVE')
            ->first();
        return $levelPlanningUnit;
    }


    function saveLevelPlanningUnit($serial_lvl,$serial_set,$serial_put,$serial_aca){
        $levelPlanningUnit = new LevelPlanningUnit();
        $levelPlanningUnit->serial_lvl=$serial_lvl;
        $levelPlanningUnit->serial_set=$serial_set;
        $levelPlanningUnit->serial_put=$serial_put;
        $levelPlanningUnit->selectable='YES';
        $levelPlanningUnit->status_lpu='ACTIVE';
        $levelPlanningUnit->serial_aca=$serial_aca;
        $levelPlanningUnit->save();
        return $levelPlanningUnit;
    }


}
