<?php

namespace App\Repositories;

use App\Models\LevelResourcesUnit;
use App\Models\LevelPlanningUnit;
use App\Models\SubjectPlanningUnit;


class LevelResourcesUnitRepository extends BaseRepository {

    protected $modelClass = LevelResourcesUnit::class;

    protected $levelResourcesUnit;


    public function __construct(LevelResourcesUnit $levelResourcesUnit) {
        $this->levelResourcesUnit = $levelResourcesUnit;
    }

    public function getLevelResourcesUnitSelectable($serial_spu) {
        $levelResourcesUnit = $this->newQuery();
        $subjectPlanningUnit = SubjectPlanningUnit::where('serial_spu', '=', $serial_spu)
            ->where('status_spu', '=', 'ACTIVE')
            ->first();
        $levelPlanningUnit = LevelPlanningUnit::where('serial_lpu', '=', $subjectPlanningUnit->serial_lpu)
            ->where('status_lpu', '=', 'ACTIVE')
            ->first();
        $levelResourcesUnit->where('selectable', '=', 'YES')
            ->where('serial_aca', '=', $levelPlanningUnit->serial_aca)
            ->where('serial_lvl', '=', $levelPlanningUnit->serial_lvl)
            ->where('serial_set', '=', $levelPlanningUnit->serial_set)
            ->where('status_lru', '=', 'ACTIVE')
            ->with('resourcesPlanningUnit')
            ->with(array('subjectResourcesUnit' => function ($query) use ($serial_spu) {
                $query->where('serial_spu', '=', $serial_spu);
            }));
        $levelResourcesUnits = $this->doQueryGet($levelResourcesUnit);
        if (sizeof($levelResourcesUnits) > 0) {
            foreach ($levelResourcesUnits as $key => $levelResourcesUnitObj) {
                $result[$key]['serial_lru'] = $levelResourcesUnitObj->serial_lru;
                $result[$key]['description_rpu'] = $levelResourcesUnitObj->resourcesPlanningUnit->description_rpu;
                $result[$key]['is_ministry_rpu'] = $levelResourcesUnitObj->resourcesPlanningUnit->is_ministry_rpu;
                $result[$key]['assigned'] = $levelResourcesUnitObj->subjectResourcesUnit != null ? true : false;
            }
        } else {
            $result = false;
        }
        return $result;
    }


    function saveLevelResourcesUnit($serial_lvl, $serial_set, $serial_rpu, $serial_aca) {
        $levelResourcesUnit = new LevelResourcesUnit();
        $levelResourcesUnit->serial_lvl = $serial_lvl;
        $levelResourcesUnit->serial_set = $serial_set;
        $levelResourcesUnit->serial_rpu = $serial_rpu;
        $levelResourcesUnit->selectable = 'YES';
        $levelResourcesUnit->status_lru = 'ACTIVE';
        $levelResourcesUnit->serial_aca = $serial_aca;
        $levelResourcesUnit->save();
        return $levelResourcesUnit;
    }


}
