<?php

namespace App\Repositories;

use App\Models\LevelStrategiesUnit;
use App\Models\LevelPlanningUnit;
use App\Models\SubjectPlanningUnit;


class LevelStrategiesUnitRepository extends BaseRepository {

    protected $modelClass = LevelStrategiesUnit::class;

    protected $levelStrategiesUnit;


    public function __construct(LevelStrategiesUnit $levelStrategiesUnit) {
        $this->levelStrategiesUnit = $levelStrategiesUnit;
    }

    public function getLevelStrategiesUnitSelectable($serial_spu) {
        $levelStrategiesUnit = $this->newQuery();
        $subjectPlanningUnit = SubjectPlanningUnit::where('serial_spu', '=', $serial_spu)
            ->where('status_spu', '=', 'ACTIVE')
            ->first();
        $levelPlanningUnit = LevelPlanningUnit::where('serial_lpu', '=', $subjectPlanningUnit->serial_lpu)
            ->where('status_lpu', '=', 'ACTIVE')
            ->first();
        $levelStrategiesUnit->where('selectable', '=', 'YES')
            ->where('serial_aca', '=', $levelPlanningUnit->serial_aca)
            ->where('serial_lvl', '=', $levelPlanningUnit->serial_lvl)
            ->where('serial_set', '=', $levelPlanningUnit->serial_set)
            ->where('status_lsu', '=', 'ACTIVE')
            ->with('methodologicalStrategiesUnit')
            ->with(array('subjectStrategiesUnit' => function ($query) use ($serial_spu) {
                $query->where('serial_spu', '=', $serial_spu);
            }));
        $levelStrategiesUnits = $this->doQueryGet($levelStrategiesUnit);
        if (sizeof($levelStrategiesUnits) > 0) {
            foreach ($levelStrategiesUnits as $key => $levelStrategiesUnitObj) {
                $result[$key]['serial_lsu'] = $levelStrategiesUnitObj->serial_lsu;
                $result[$key]['description_msu'] = $levelStrategiesUnitObj->methodologicalStrategiesUnit->description_msu;
                $result[$key]['is_ministry_msu'] = $levelStrategiesUnitObj->methodologicalStrategiesUnit->is_ministry_msu;
                $result[$key]['assigned'] = $levelStrategiesUnitObj->subjectStrategiesUnit != null ? true : false;
            }
        } else {
            $result = false;
        }
        return $result;
    }


    function saveLevelStrategiesUnit($serial_lvl, $serial_set, $serial_msu, $serial_aca) {
        $levelStrategiesUnit = new LevelStrategiesUnit();
        $levelStrategiesUnit->serial_lvl = $serial_lvl;
        $levelStrategiesUnit->serial_set = $serial_set;
        $levelStrategiesUnit->serial_msu = $serial_msu;
        $levelStrategiesUnit->selectable = 'YES';
        $levelStrategiesUnit->status_lsu = 'ACTIVE';
        $levelStrategiesUnit->serial_aca = $serial_aca;
        $levelStrategiesUnit->save();
        return $levelStrategiesUnit;
    }


}
