<?php

namespace App\Repositories;

use App\Models\OptStudentCriteriaGrade;
use App\Models\Period;
use App\Repositories\BaseRepository;

class OptStudentCriteriaGradeRepository extends BaseRepository {

    protected $modelClass = OptStudentCriteriaGrade::class;
    protected $optStudentCriteriaGrade;
    protected $period;

   //Declaración del constructor
    public function __construct(OptStudentCriteriaGrade $optStudentCriteriaGrade,Period $period) {
        $this->optStudentCriteriaGrade = $optStudentCriteriaGrade;
        $this->period=$period;
    }


    public function getActivitiesByActivityTypeBySubperiod($serial_osb, $serial_prd, $serial_sbp, $serial_scy, $serial_std, $serial_att)
    {

        $gradesActivities = $this->newQuery();
        $gradesActivities->leftJoin(\DB::raw("(SELECT scg.serial_att,act.serial_opa,act.name_opa,act.due_date_opa,scg.serial_osb,sbp.serial_sbp, SUM( scg.activity_grade_part_osg ) AS grade_sum
                                FROM opt_student_criteria_grade scg                                
                                JOIN opt_activity act ON act.serial_opa = scg.serial_opa AND act.status_opa = 'ACTIVE'
                                JOIN period prd ON prd.serial_prd=scg.serial_prd
                                JOIN subperiod sbp ON sbp.serial_prd=prd.serial_prd  AND DATE(act.due_date_opa) BETWEEN sbp.start_date_sbp  AND sbp.end_date_sbp
                                WHERE scg.serial_prd =$serial_prd
                                AND sbp.serial_sbp=$serial_sbp
                                AND scg.serial_osb =$serial_osb
                                AND scg.serial_std =$serial_std
                                
                                AND scg.status_osg='ACTIVE'
                                GROUP BY scg.serial_std, scg.serial_opa, scg.serial_att
                                ) as atp"), function ($join) {
            $join->on('atp.serial_att', '=', 'opt_student_criteria_grade.serial_att');
        });
        $gradesActivities->join('student_optional_subject', function ($join) use ($serial_std, $serial_prd) {
            $join->on('student_optional_subject.serial_osb', '=', 'atp.serial_osb')
                ->where('student_optional_subject.serial_std', '=', $serial_std)
                ->where('student_optional_subject.serial_prd', '=', $serial_prd)
                ->where('status_sos', '=', 'ACTIVE');
        });
        $gradesActivities->join('level_optional_group', function ($join) {
            $join->on('level_optional_group.serial_lop', '=', 'student_optional_subject.serial_lop')
                ->where('status_lop', '=', 'ACTIVE');
        });
        $gradesActivities->where('level_optional_group.serial_scy', $serial_scy);
        $gradesActivities->where('opt_student_criteria_grade.serial_std', '=', $serial_std);
        $gradesActivities->where('opt_student_criteria_grade.serial_osb', '=', $serial_osb);
        $gradesActivities->where('opt_student_criteria_grade.serial_prd', '=', $serial_prd);
        $gradesActivities->where('atp.serial_sbp', '=', $serial_sbp);
        $gradesActivities->where('opt_student_criteria_grade.serial_att', '=', $serial_att);
        $gradesActivities->selectRaw("DISTINCT atp.serial_opa as serial_act, atp.name_opa as name_act, DATE_FORMAT(atp.due_date_opa, '%d/%m/%Y') as due_date_act,
						atp.grade_sum as act_grade");
        return $this->doQueryGet($gradesActivities);
   }

}
