<?php
/**
 * Repositorio para consultas sobre estado/provincias.
 * User: Henry Vivanco <hvvivanco@rutatec.com>
 * Date: 21/1/2019
 * Time: 15:30
 */

namespace App\Repositories;


use App\Models\State;

class StateRepository extends BaseRepository
{
    protected $state;

    public function __construct(State $state)
    {
        $this->state = $state;
    }

    /**
     * Método para obtener provincias(estados) según el país
     * @author Henry Vivanco <hvvivanco@rutatec.com>
     * @since  2019-01-21
     * @return array $states
     */
    public function getStates($serialCountry){
        $states = State::where('status_ste','=','ACTIVE')
            ->where('serial_cou','=',$serialCountry)
            ->pluck('name_ste','serial_ste');
        return $states;
    }

}