<?php

namespace App\Repositories;

use App\Models\Period;
use App\Models\StudentCriteriaGrade;
use App\Repositories\BaseRepository;

class StudentCriteriaGradeRepository extends BaseRepository {

    protected $modelClass = StudentCriteriaGrade::class;
    protected $studentCriteriaGrade;
    protected $period;

   //Declaración del constructor
    public function __construct(StudentCriteriaGrade $studentCriteriaGrade, Period $period)
    {
        $this->studentCriteriaGrade = $studentCriteriaGrade;
        $this->period = $period;
    }

   public function getActivitiesByActivityTypeBySubperiod($serial_sbc, $serial_prd, $serial_sbp, $serial_scy, $serial_std, $serial_att){

       $gradesActivities = $this->newQuery();
       $gradesActivities->leftJoin(\DB::raw("(SELECT scg.serial_att,act.serial_act,act.name_act,act.due_date_act,scg.serial_crs,sbp.serial_sbp, SUM( scg.activity_grade_part_scg ) AS grade_sum
                                FROM student_criteria_grade scg                                
                                JOIN activity act ON act.serial_act = scg.serial_act AND act.status_act = 'ACTIVE'
                                JOIN period prd ON prd.serial_prd=scg.serial_prd
                                JOIN subperiod sbp ON sbp.serial_prd=prd.serial_prd  AND DATE(act.due_date_act) BETWEEN sbp.start_date_sbp  AND sbp.end_date_sbp
                                WHERE scg.serial_prd =$serial_prd
                                AND sbp.serial_sbp=$serial_sbp
                                AND scg.serial_sbc =$serial_sbc
                                AND scg.serial_std =$serial_std
                                
                                AND scg.status_scg='ACTIVE'
                                GROUP BY scg.serial_std, scg.serial_act, scg.serial_att) as atp"), function ($join) {
           $join->on('atp.serial_att', '=', 'student_criteria_grade.serial_att');
       });
       $gradesActivities->join('course', function ($join) {
           $join->on('course.serial_crs', '=', 'atp.serial_crs')
               ->where('status_crs', '=', 'ACTIVE');
       });
       $gradesActivities->where('course.serial_scy', '=', $serial_scy);
       $gradesActivities->where('student_criteria_grade.serial_std', '=', $serial_std);
       $gradesActivities->where('student_criteria_grade.serial_sbc', '=', $serial_sbc);
       $gradesActivities->where('student_criteria_grade.serial_prd', '=', $serial_prd);
       $gradesActivities->where('atp.serial_sbp', '=', $serial_sbp);
       $gradesActivities->where('student_criteria_grade.serial_att', '=', $serial_att);
       $gradesActivities->selectRaw("DISTINCT atp.serial_act, atp.name_act, DATE_FORMAT(atp.due_date_act, '%d/%m/%Y') as due_date_act,
						atp.grade_sum as act_grade");
       return $this->doQueryGet($gradesActivities);
   }

}
