<?php

namespace App\Repositories;

use App\Models\SubjectPeriodActivityType;
use App\Repositories\BaseRepository;

class SubjectPeriodActivityTypeRepository extends BaseRepository {

    protected $modelClass = SubjectPeriodActivityType::class;
    protected $subjectPeriodActivityType;

   //Declaración del constructor
    public function __construct(SubjectPeriodActivityType $subjectPeriodActivityType) {
        $this->subjectPeriodActivityType = $subjectPeriodActivityType;
    }

   public function getActivityTypesBySubjectBySubperiodByStudent($serial_prd,$serial_sbc){
        $grades=$this->newQuery();
        $grades->join('activity_type','activity_type.serial_att','=','subject_period_activity_type.serial_att');
        $grades->where('serial_prd','=',$serial_prd);
        $grades->where('serial_sbc','=',$serial_sbc);
        $grades->where('status_spa','=','ACTIVE');
        $grades->where('activity_type.serial_att','<>' ,1);
        $grades->select('activity_type.serial_att','activity_type.name_att');
        $grades->orderBy('serial_att');
        return $this->doQueryGet($grades);
   }

}
